Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | File Members

# RandomPool Class Reference

`#include <randpool.h>`

Inheritance diagram for RandomPool:

List of all members.

## Detailed Description

Randomness Pool.

This class can be used to generate pseudorandom bytes after seeding the pool with the Put() methods

Definition at line 13 of file randpool.h.

## SIGNALS
virtual bool | IsolatedMessageSeriesEnd (bool blocking)
virtual void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
virtual bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
virtual bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
virtual void | SetAutoSignalPropagation (int propagation)
| set propagation of automatically generated and transferred signals
virtual int | GetAutoSignalPropagation () const
## ATTACHMENT
virtual bool | Attachable ()
| returns whether this object allows attachment
virtual BufferedTransformation * | AttachedTransformation ()
| returns the object immediately attached to this object or NULL for no attachment
virtual const BufferedTransformation * | AttachedTransformation () const
virtual void | Detach (BufferedTransformation *newAttachment=0)
| delete the current attachment chain and replace it with newAttachment
virtual void | Attach (BufferedTransformation *newAttachment)
| add newAttachment to the end of attachment chain
## Public Member Functions
| RandomPool (unsigned int poolSize=384)
| poolSize must be greater than 16
unsigned int | Put2 (const byte *begin, unsigned int, int messageEnd, bool blocking)
| input multiple bytes for blocking or non-blocking processing
bool | AnyRetrievable () const
| returns whether any bytes are currently ready for retrieval
unsigned long | MaxRetrievable () const
| returns number of bytes that is currently ready for retrieval
unsigned int | TransferTo2 (BufferedTransformation &target, unsigned long &transferBytes, const std::string &channel=NULL_CHANNEL, bool blocking=true)
unsigned int | CopyRangeTo2 (BufferedTransformation &target, unsigned long &begin, unsigned long end=ULONG_MAX, const std::string &channel=NULL_CHANNEL, bool blocking=true) const
byte | GenerateByte ()
| generate new random byte and return it
void | GenerateBlock (byte *output, unsigned int size)
| generate random array of bytes
void | IsolatedInitialize (const NameValuePairs &parameters)
virtual unsigned int | GenerateBit ()
| generate new random bit and return it
virtual word32 | GenerateWord32 (word32 a=0, word32 b=0xffffffffL)
| generate a random 32 bit word in the range min to max, inclusive
virtual void | DiscardBytes (unsigned int n)
| generate and discard n bytes
template<class IT> void | Shuffle (IT begin, IT end)
| randomly shuffle the specified array, resulting permutation is uniformly distributed
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
bool | IsolatedFlush (bool hardFlush, bool blocking)
BufferedTransformation & | Ref ()
| return a reference to this object
bool | Wait (unsigned long milliseconds)
| wait on this object
## Static Public Attributes
const std::string | NULL_CHANNEL
## Protected Member Functions
void | Stir ()
## Static Protected Member Functions
int | DecrementPropagation (int propagation)

## Member Function Documentation

unsigned int RandomPool::Put2 | ( | const byte * | begin,
|  | unsigned | int,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[virtual]`

  | input multiple bytes for blocking or non-blocking processing Parameters:
  | messageEnd | means how many filters to signal MessageEnd to, including this one
Implements BufferedTransformation. Definition at line 43 of file randpool.cpp. References SecBlock< T, A >::size().

unsigned long RandomPool::MaxRetrievable | ( |  | ) | const`[inline, virtual]`

| returns number of bytes that is currently ready for retrieval All retrieval functions return the actual number of bytes retrieved, which is the lesser of the request number and MaxRetrievable(). Reimplemented from BufferedTransformation. Definition at line 23 of file randpool.h.

void RandomPool::GenerateBlock | ( | byte * | output,
|  | unsigned int | size
| ) | `[virtual]`

| generate random array of bytes Default implementation is to call GenerateByte() size times. Reimplemented from RandomNumberGenerator. Definition at line 97 of file randpool.cpp. References BufferedTransformation::TransferTo().

unsigned int RandomNumberGenerator::GenerateBit | ( |  | ) | `[virtual, inherited]`

| generate new random bit and return it Default implementation is to call GenerateByte() and return its parity. Reimplemented in PublicBlumBlumShub. Definition at line 111 of file cryptlib.cpp. References RandomNumberGenerator::GenerateByte().

void RandomNumberGenerator::DiscardBytes | ( | unsigned int | n | ) | `[virtual, inherited]`

| generate and discard n bytes Default implementation is to call GenerateByte() n times. Reimplemented in ARC4_Base. Definition at line 142 of file cryptlib.cpp. References RandomNumberGenerator::GenerateByte().

BufferedTransformation& BufferedTransformation::Ref | ( |  | ) | `[inline, inherited]`

| return a reference to this object This function is useful for passing a temporary BufferedTransformation object to a function that takes a non-const reference. Definition at line 711 of file cryptlib.h.

virtual byte* BufferedTransformation::CreatePutSpace | ( | unsigned int & | size | ) | `[inline, virtual, inherited]`

| request space which can be written into by the caller, and then used as input to Put() Note: The purpose of this method is to help avoid doing extra memory allocations. Reimplemented in MeterFilter, HashFilter, Redirector, ArraySink, ArrayXorSink, and ByteQueue. Definition at line 730 of file cryptlib.h. Referenced by ArrayXorSink::CreatePutSpace().

virtual unsigned int BufferedTransformation::PutModifiable2 | ( | byte * | inString,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[inline, virtual, inherited]`

  | input multiple bytes that may be modified by callee for blocking or non-blocking processing Parameters:
  | messageEnd | means how many filters to signal MessageEnd to, including this one
Reimplemented in MeterFilter, and FilterWithBufferedInput. Definition at line 748 of file cryptlib.h.

bool BufferedTransformation::Flush | ( | bool | hardFlush,
|  | int | propagation = `-1`,
|  | bool | blocking = `true`
| ) | `[virtual, inherited]`

  | flush buffered input and/or output Parameters:
  | hardFlush | is used to indicate whether all data should be flushed
Note: Hard flushes must be used with care. It means try to process and output everything, even if there may not be enough data to complete the action. For example, hard flushing a HexDecoder would cause an error if you do it after inputing an odd number of hex encoded characters. For some types of filters, for example ZlibDecompressor, hard flushes can only be done at "synchronization points". These synchronization points are positions in the data stream that are created by hard flushes on the corresponding reverse filters, in this example ZlibCompressor. This is useful when zlib compressed data is moved across a network in packets and compression state is preserved across packets, as in the ssh2 protocol. Reimplemented in Filter, Redirector, SecretSharing, and InformationDispersal. Definition at line 195 of file cryptlib.cpp. References BufferedTransformation::AttachedTransformation().

bool BufferedTransformation::MessageSeriesEnd | ( | int | propagation = `-1`,
|  | bool | blocking = `true`
| ) | `[virtual, inherited]`

| mark end of a series of messages There should be a MessageEnd immediately before MessageSeriesEnd. Reimplemented in Filter, and Redirector. Definition at line 201 of file cryptlib.cpp. References BufferedTransformation::AttachedTransformation().

virtual void BufferedTransformation::SetAutoSignalPropagation | ( | int | propagation | ) | `[inline, virtual, inherited]`

| set propagation of automatically generated and transferred signals propagation == 0 means do not automaticly generate signals Reimplemented in SourceTemplate< T >, SourceTemplate< FileStore >, SourceTemplate< RandomNumberStore >, and SourceTemplate< StringStore >. Definition at line 788 of file cryptlib.h.

bool BufferedTransformation::GetNextMessage | ( |  | ) | `[virtual, inherited]`

| start retrieving the next message Returns false if no more messages exist or this message is not completely retrieved. Reimplemented in MessageQueue, and Store. Definition at line 336 of file cryptlib.cpp. References BufferedTransformation::AnyMessages(), and BufferedTransformation::AttachedTransformation().

virtual bool BufferedTransformation::Attachable | ( |  | ) | `[inline, virtual, inherited]`

| returns whether this object allows attachment Some BufferedTransformation objects (e.g. Filter objects) allow other BufferedTransformation objects to be attached. When this is done, the first object instead of buffering its output, sents that output to the attached object as input. The entire attachment chain is deleted when the anchor object is destructed. Reimplemented in Filter. Definition at line 934 of file cryptlib.h. Referenced by BufferedTransformation::Attach().

bool Waitable::Wait | ( | unsigned long | milliseconds | ) | `[inherited]`

| wait on this object same as creating an empty container, calling GetWaitObjects(), and calling Wait() on the container Definition at line 321 of file wait.cpp. References Waitable::GetWaitObjects(), and WaitObjectContainer::Wait(). Referenced by NetworkSource::GeneralPump2(), and NetworkSink::TimedFlush().

The documentation for this class was generated from the following files:

- randpool.h
- randpool.cpp